<!--********************************************************************************
 * Copyright (c) 2024 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************-->

<br />

<p-table
  [value]="catalogAttributes"
  selectionMode="single"
  [(selection)]="selectedCatalogAttribute"
  dataKey="id"
  editMode="row"
  (onEditComplete)="onEditComplete($event)"
  (onEditInit)="onAttrEditInit($event)"
  styleClass="p-datatable-sm p-datatable-striped p-datatable-gridlines"
>
  <ng-template pTemplate="caption">
    <div class="flex align-items-center justify-content-end">
      <span></span>
      <p-button
        class="mx-1"
        icon="pi pi-plus"
        (click)="openCreateAttributeDialog()"
        [label]="'administration.catalog.newAttribute' | translate"
      >
      </p-button>
      <p-button
        class="mx-1"
        icon="pi pi-language"
        (click)="onShowTranslations()"
        [label]="'administration.catalog.showTranslations' | translate"
      >
      </p-button>
    </div>
  </ng-template>
  <ng-template pTemplate="header">
    <tr>
      <th>{{ "administration.catalog.name" | translate }}</th>
      <th>{{ "administration.catalog.data-type" | translate }}</th>
      <th>{{ "administration.catalog.copyable" | translate }}</th>
      <th>{{ "administration.catalog.unit" | translate }}</th>
      <th>{{ "administration.catalog.valueList" | translate }}</th>
      <th>{{ "administration.catalog.valueListRef" | translate }}</th>
      <th>{{ "administration.catalog.description" | translate }}</th>
      <th></th>
    </tr>
  </ng-template>
  <ng-template pTemplate="body" let-attribute let-editing="editing">
    <tr [pEditableRow]="attribute">
      <td>{{ attribute.name }}</td>
      <td>{{ attribute.dataType }}</td>
      <td class="text-center" [pEditableColumn]="attribute">
        <p-checkbox trueValue="true" falseValue="false" [(ngModel)]="attribute.valueCopyable" [binary]="true"></p-checkbox>
      </td>
      <td [pEditableColumn]="attribute">
        <p-cellEditor>
          <ng-template pTemplate="input">
            <p-dropdown
              placeholder="-"
              [options]="units"
              [(ngModel)]="attribute.unit"
              optionLabel="name"
              optionValue="id"
              appendTo="body"
            ></p-dropdown>
          </ng-template>
          <ng-template pTemplate="output">
            <span *ngFor="let unit of units">
              {{ unit.id === attribute.unit ? unit.name : "" }}
            </span>
          </ng-template>
        </p-cellEditor>
      </td>
      <td [pEditableColumn]="attribute">
        <p-cellEditor>
          <ng-template pTemplate="input">
            <p-dropdown
              placeholder="-"
              [options]="valueLists"
              [(ngModel)]="attribute.valueListRelationId"
              optionLabel="name"
              optionValue="id"
              appendTo="body"
            ></p-dropdown>
          </ng-template>
          <ng-template pTemplate="output">
            <span *ngFor="let value of valueLists">
              {{ value.id === attribute.valueListRelationId ? value.name : "" }}
            </span>
          </ng-template>
        </p-cellEditor>
      </td>
      <td class="text-center" [pEditableColumn]="attribute">
        <p-checkbox trueValue="true" falseValue="false" [(ngModel)]="attribute.valueListRef" [binary]="true"></p-checkbox>
      </td>
      <td [pEditableColumn]="attribute">
        <p-cellEditor>
          <ng-template pTemplate="input">
            <input class="form-control" pInputText type="text" [(ngModel)]="attribute.description" />
          </ng-template>
          <ng-template pTemplate="output">
            {{ attribute.description }}
          </ng-template>
        </p-cellEditor>
      </td>
      <td>
        <p-button icon="pi pi-trash" (click)="openDeleteAttributeDialog(attribute.id)"></p-button>
      </td>
    </tr>
  </ng-template>
</p-table>

<!-- create attribute dialog -->
<p-dialog
  class="create-attr"
  [header]="'administration.catalog.create-attribute-title' | translate"
  [(visible)]="dialogCatalogAttributeCreate"
  [style]="{ width: '25vw' }"
>
  <div class="py-2 d-flex">
    <span class="pr-2 col-4">{{ "administration.catalog.attr-name" | translate }}</span>
    <input required class="form-control" type="text" [(ngModel)]="newAttributeInstance.Name" />
  </div>
  <div class="py-2 d-flex">
    <span class="pr-2 col-4">{{ "administration.catalog.data-type" | translate }}</span>
    <p-dropdown [options]="dataTypes" [(ngModel)]="newAttributeInstance.DataType" appendTo="body"></p-dropdown>
  </div>
  <p-footer>
    <p-button [label]="'administration.catalog.btn-add' | translate" (click)="createCatalogAttribute()"> </p-button>
    <p-button [label]="'administration.catalog.btn-cancel' | translate" (click)="closeCreateAttributeDialog()"> </p-button>
  </p-footer>
</p-dialog>

<!-- Delete attribute dialog -->
<p-dialog [header]="'administration.catalog.deleteAttr' | translate" [(visible)]="dialogCatalogAttributeDelete" [style]="{ width: '25vw' }">
  <span>{{ "administration.catalog.delete-dialog" | translate }}</span>
  <p-footer>
    <p-button [label]="'administration.catalog.btn-del' | translate" (click)="deleteAttribute()"> </p-button>
    <p-button [label]="'administration.catalog.btn-cancel' | translate" (click)="closeDeleteAttributeDialog()"> </p-button>
  </p-footer>
</p-dialog>

<p-dialog [header]="'administration.catalog.editTranslations' | translate" [(visible)]="showTranslations" [style]="{ width: '50vw' }">
  <p-table [value]="translations?.attributes | keyvalue">
    <ng-template pTemplate="header">
      <tr>
        <th>{{ "administration.catalog.name" | translate }}</th>
        <th *ngFor="let l of translations?.languages"><img class="mx-1" [src]="'assets/famfamfam_icons/' + l + '.png'" />{{ l }}</th>
      </tr>
    </ng-template>
    <ng-template pTemplate="body" let-attribute let-rowIndex="rowIndex">
      <tr *ngIf="rowIndex === 0" style="border-bottom: 2px solid black">
        <td class="vertical-align-middle">{{ catalogComponent?.name }}</td>
        <td *ngFor="let l of translations?.languages; let langIndex = index">
          <input class="w-full" type="text" pInputText [(ngModel)]="translations?.componentName[langIndex]" />
        </td>
      </tr>
      <tr>
        <td class="vertical-align-middle">{{ attribute?.key }}</td>
        <td *ngFor="let l of translations?.languages; let langIndex = index">
          <input class="w-full" type="text" pInputText [(ngModel)]="attribute?.value[langIndex]" />
        </td>
      </tr>
    </ng-template>
  </p-table>

  <p-footer>
    <p-button [label]="'administration.catalog.btn-save' | translate" (click)="saveTranslations()"> </p-button>
    <p-button [label]="'administration.catalog.btn-cancel' | translate" (click)="closeTranslationsDialog()"> </p-button>
  </p-footer>
</p-dialog>
